<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>

<%@ taglib prefix="core" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib uri="/WEB-INF/tld/struts-bean.tld" prefix="bean"%> 
<!-- JS Resources -->
<script type="text/javascript">
	
	var configObject = {
		entity: '',
		renderTo: 'panel${clase}',
		panelId: 'panel${clase}',
		addUrl:			'../app/${claseUncapitalize}.do?method=alta${clase}',
		modifyUrl:		'../app/${claseUncapitalize}.do?method=modificar${clase}',
		removeUrl: 		'../app/${claseUncapitalize}.do?method=baja${clase}',
		loadDataUrl:	'../app/${claseUncapitalize}.do?method=loadData',
		filterDataUrl:	'../app/${claseUncapitalize}.do?method=filtrar'
	};

	var filterConfig = {
		urls: {
		    pagingToolbarFilterUrl: '../app/${claseUncapitalize}.do?method=filtrar',
			pagingToolbarUrl: 		'../app/${claseUncapitalize}.do?method=loadData',
			exportToolbarUrl: '../app/export.do?method=exportExcel'
		}
	};
#if (${lupas.size()} > 0)
	var lupaConfig =  {
		urls: {
#foreach($atributo in $lupas)
			${atributo.getName().toLowerCase()}DescriptionRetrival: '../app/lupas.do?method=getDescription',
			${atributo.getName().toLowerCase()}Url: '../app/lupas.do?method=filtrar'#if( $velocityCount < ${lupas.size()}), #end

#end
		},
		entities: {
#foreach($atributo in $lupas)
			${atributo.getName().toLowerCase()}Name: '${atributo.getCampoExcel().getNombreLupa()}'#if($velocityCount < ${lupas.size()}), #end

#end
		}
	};
#end
	Tera.onReady(function(){

		Tera.QuickTips.init();
		Tera.BLANK_IMAGE_URL = '../img/default/s.gif';
#if($filtros.size() != 0)
		var filtroBusqueda = new Tera.form.FilterPanel({
			mappedFields: [ 
#foreach($filtro in $filtros)
'${filtro.getName().toLowerCase()}Filter'#if( $velocityCount < ${filtros.size()}), #end
#end			
			],
			filterConfig: filterConfig,
	        bodyBorder: false,
	        border: false,
	        bodyStyle: 'padding:10px',
	        buttonAlign: 'right',
	        width: 550,
	        baseCls: 'x-plain',
	        labelWidth: 130,
	        items: [
#foreach($atributo in $filtros)

#if ($atributo.getCampoExcel().getTieneLupa() == "S")
				new Tera.form.LupaField({
					fieldLabel: '${atributo.getEtiquetaCorta()}',
					width: ${atributo.getAnchoDelCampo()} + 17,
					id: '${atributo.getName().toLowerCase()}Filter',
					name: '${atributo.getName().toLowerCase()}Filter',
					descriptionRetrival: lupaConfig.urls.${atributo.getName().toLowerCase()}DescriptionRetrival,
					url: lupaConfig.urls.${atributo.getName().toLowerCase()}Url,
					entityName: lupaConfig.entities.${atributo.getName().toLowerCase()}Name
				})#if( $velocityCount < ${filtros.size()}), #end
#end
#if ($atributo.getCampoExcel().getTieneLupa() != "S")
			{
#if ($atributo.getType() == "java.util.Date")
				xtype:'datefield', format: 'd/m/Y',
#end
#if ($atributo.getType() == "String")
	            xtype: 'textfield', 
#end
#if ($atributo.getType() == "Double" || $atributo.getType() == "java.math.BigDecimal")
	            xtype: 'numberfield',
#end
				width: ${atributo.getAnchoDelCampo()},
				fieldLabel: '${atributo.getEtiquetaCorta()}',
				name: '${atributo.getName().toLowerCase()}Filter',
				id: '${atributo.getName().toLowerCase()}Filter',
				height: 21,
				maxLength: ${atributo.getMaxLen()},
				maxLengthText: 'El campo tiene un m&aacute;ximo de ${atributo.getMaxLen()} car&aacute;cteres'

			}#if( $velocityCount < ${filtros.size()}), #end
#end
#end
			]
	    });
#end
	    var store = new Tera.data.JsonStore({
	        url: configObject.loadDataUrl,
	        root: 'data',
	        totalProperty: 'totalCount',
	        id: 'cod${clase}',
	        fields: [
#foreach($atributo in $atributos)	
	        '${atributo.getName().toLowerCase()}'#if( $velocityCount < ${atributos.size()}), #end

#end	     
	        ]
	    });
	
	 	function changeNumber(val){
        	var original=parseFloat(val);
			var result = original.toFixed(2);
        	if(val < 0){
 	           	return '<span style="color:red;">' + result + '</span>';
        	}
    
        	return result;
    	}
	
	    var cm${clase} = new Tera.grid.ColumnModel([
		    new Tera.grid.RowNumberer(),
#foreach($atributo in $atributos)
#if ( $atributo.getType() == "java.util.Date")
		    {id: '${atributo.getName().toLowerCase()}', header: '${atributo.getEtiquetaCorta()}', dataIndex: '${atributo.getName().toLowerCase()}', width: '${atributo.getEtiquetaCorta()}'.length * 8, align:'center'}#if( $velocityCount < ${atributos.size()}), #end
#end
#if ( $atributo.getType() == "String")
		    {id: '${atributo.getName().toLowerCase()}', header: '${atributo.getEtiquetaCorta()}', dataIndex: '${atributo.getName().toLowerCase()}', width: '${atributo.getEtiquetaCorta()}'.length * 8, align:'center'}#if( $velocityCount < ${atributos.size()}), #end
#end
#if ($atributo.getType() == "Double" || $atributo.getType() == "java.math.BigDecimal")
		    {id: '${atributo.getName().toLowerCase()}', header: '${atributo.getEtiquetaCorta()}', renderer: changeNumber, dataIndex: '${atributo.getName().toLowerCase()}', width: '${atributo.getEtiquetaCorta()}'.length * 8, align:'center'}#if( $velocityCount < ${atributos.size()}), #end
#end

#end
	    ]);
	    cm${clase}.defaultSortable = true;
	
	    var grid${clase} = new Tera.grid.GridPanel({
	        width: 625,
	        height: 245,
	        store: store,
	        cm: cm${clase},
	        trackMouseOver: true,
	        sm: new Tera.grid.RowSelectionModel( { singleSelect: true } ),
	        loadMask: true,
	        stripeRows: true,
	        viewConfig: {
	            forceFit: false,
	            enableRowBody: false
	        },
	        bbar: new Tera.PagingToolbar({
#if($filtros.size() != 0)
	        	filterPanel: filtroBusqueda,
#end
#if($filtros.size() == 0)
				exportUrl: filterConfig.urls.exportToolbarUrl,
#end
	        	exportFile: true,
	            exportGridName: '${clase}',
	            pageSize: 10,
	            store: store,
	            displayInfo: true,
	            displayMsg: 'Mostrando   {0} - {1} de {2}',
	            emptyMsg: 'No existen registros a mostrar.'
	        })
	    });

		grid${clase}.addListener('click', function(param) {
			if(grid${clase}.getSelectionModel().hasSelection()){
	   			buttonBaja.setDisabled(false);
	   			buttonModificar.setDisabled(false); 
	   			buttonVisualizar.setDisabled(false);
	    	} else{
	    		buttonBaja.setDisabled(true);
	   			buttonModificar.setDisabled(true);  
	   			buttonVisualizar.setDisabled(true);
	    	}
	    });

    	store.load({params: {start: 0,limit: 10}}); 
	    
	    var buttonAlta = new Tera.Button({text: 'Alta', minWidth: 80});
	    var buttonBaja = new Tera.Button({text: 'Baja', minWidth: 80, disabled: true});
	    var buttonModificar = new Tera.Button({text: 'Modificar', minWidth: 80, disabled: true});
	    var buttonVisualizar = new Tera.Button({text: 'Visualizar', minWidth: 80, disabled: true});
#if($filtros.size() != 0)	    
	    var buttonFiltrar = new Tera.Button({
	        text: 'Filtrar',
			minWidth: 80,
			handler: function(){
				filtroBusqueda.getForm().submit({
					waitMsg: 'Cargando datos...',
					url: configObject.filterDataUrl,
					success: function(response, options){
						var responseText = Tera.decode(options.response.responseText);
						if (responseText.data != 'undefined' || responseText.data != null){
							grid${clase}.getStore().loadData(responseText.data);
						}
					},
					failure: function(response, options){
						var responseText = Tera.decode(options.response.responseText);
						Tera.MessageBox.alert('Error en filtrado', responseText.failure); 
					}
				});
			}
		});
	    
	    var buttonLimpiar = new Tera.Button({text: 'Limpiar',
			minWidth: 80,
			handler: function(){
#foreach($atributo in $filtros)
	    		Tera.getCmp("${atributo.getName().toLowerCase()}Filter").setValue('');
#end
	    		grid${clase}.getStore().load();
			}
		});
#end	   
		var panel = new Tera.Panel({
	    	id: configObject.panelId,
	    	renderTo: configObject.renderTo,
	        baseCls: 'x-plain',
	        layout:'column',
	        autoScroll: true,
	        items:[
#if($filtros.size() != 0)
	        {
	            columnWidth: .85,
	            baseCls: 'x-plain',
	            bodyStyle: 'padding:5px 0 5px 5px',
	            items:[ filtroBusqueda ]
	        },{
	            columnWidth:.15, 
	            baseCls:'x-plain',
	            bodyStyle:'padding:8px 0 5px 5px',
	            items:[{
	                bodyStyle: 'padding: 3px', 
	                baseCls: 'x-plain',
	                items: [ buttonFiltrar ]
				},{
					bodyStyle: 'padding: 3px',
					baseCls: 'x-plain',
					items: [ buttonLimpiar ]
				}]
	        },
#end
	        {
				columnWidth:.85,
	            baseCls:'x-plain',
#if($filtros.size() != 0)	            
	            bodyStyle:'padding:5px 0 5px 5px',
#end
#if($filtros.size() == 0)	            
	            bodyStyle:'padding:15px 0 5px 5px',
#end

	            items: [ grid${clase} ]
	        },{
				columnWidth: .15, 
	            baseCls: 'x-plain',
#if($filtros.size() != 0)	            
	            bodyStyle:'padding:0px 0 5px 5px',
#end
#if($filtros.size() == 0)	            
	            bodyStyle:'padding:10px 0 5px 5px',
#end
	            items:[{
	                bodyStyle: 'padding: 3px',
	                baseCls: 'x-plain',
	                items: [ buttonAlta ]
				},{
					bodyStyle: 'padding: 3px',
					baseCls: 'x-plain',
					items: [ buttonBaja ]
				},{
					bodyStyle: 'padding: 3px',
					baseCls: 'x-plain',
					items: [ buttonModificar ]
				},{
					bodyStyle: 'padding: 3px',
					baseCls: 'x-plain',
					items: [ buttonVisualizar ]
				}]
			}]
	    });
			
		buttonAlta.on('click', function(){
#if ($tieneGrilla == "S")		
			var storeGrilla2 = new Tera.data.JsonStore({
	            url: configObject.loadIdiomasUrl,
	            root: 'data',
	            totalProperty: 'totalCount',
	            id: 'codigo',
	            fields: ['codigo', 'descripcion']
	        });
	
	        var columnModel = new Tera.grid.ColumnModel([{
	            id: 'codigo',
	            header: "C&oacute;digo",
	            width: 30,
	            sortable: true,
	            dataIndex: 'codigo'
	        }, {
	            id: 'descripcion',
	            header: "Descripci&oacute;n",
	            width: 40,
	            sortable: true,
	            dataIndex: 'descripcion'
	        }]);
			var editableGrid = new Tera.grid.EditorGridPanel({
				clicksToEdit: 1,
	            store: storeGrilla2,
	            cm: columnModel,
	            stripeRows: true,
	            viewConfig: {
	                forceFit: true
	            },
	            style: 'padding-top: 10px',
	            width: ${ventanaWidth}-40,
	            height: 150,
	            frame: false
	        });
#end
		
			var form = new Tera.form.FormPanel({
				baseCls: 'x-plain',
				labelWidth: 130,
				items: [
#foreach($atributo in $camposForms)

#if ($atributo.getCampoExcel().getTieneLupa() == "S")
				new Tera.form.LupaField({
					fieldLabel: '${atributo.getEtiquetaCorta()}',
					width: ${atributo.getAnchoDelCampo()} + 17,
					id: '${atributo.getName().toLowerCase()}',
					name: '${atributo.getName().toLowerCase()}'
				})#if( $velocityCount < ${camposForms.size()}), #end
#end
#if ($atributo.getCampoExcel().getTieneLupa() != "S")
				{
#if ($atributo.getType() == "java.util.Date")
#if (!$atributo.getName().equalsIgnoreCase("FEC_BAJA"))
				xtype:'datefield', format: 'd/m/Y',
#end
#if ($atributo.getName().equalsIgnoreCase("FEC_BAJA"))
				xtype:'textfield', format: 'd/m/Y', readOnly: true,
#end

#if ($atributo.getName().equalsIgnoreCase("FEC_ALTA"))
				value: new Date(),
#end
#end
#if ($atributo.getType() == "String")
	            xtype: 'textfield',
#end
#if ($atributo.getType() == "Double" || $atributo.getType() == "java.math.BigDecimal")
	            xtype: 'numberfield',
#end
				width: ${atributo.getAnchoDelCampo()},
				fieldLabel: '${atributo.getEtiquetaCorta()}',
				name: '${atributo.getName().toLowerCase()}',
				id: '${atributo.getName().toLowerCase()}',
				maxLength: ${atributo.getMaxLen()},
				maxLengthText: 'El campo tiene un m&aacute;ximo de ${atributo.getMaxLen()} car&aacute;cteres',
				height: 21,
#if ($atributo.getCampoExcel().getEsRequeridoAlta() == "S")				
				allowBlank: false,  
#end
				msgTarget: 'side', 
				blankText: 'El campo es requerido' 
				}#if( $velocityCount < ${camposForms.size()}), #end
#end
#end
#if ($tieneGrilla == "S")
				,editableGrid
#end
				]         
			});
			
			
			
			var win = new Tera.Window({
		    	title: 'Alta',
		        border: false,
				modal: true,
#if (${lupas.size()} == 0)
				width: ${ventanaWidth},
#end
#if (${lupas.size()} > 0)
				width: ${ventanaWidth} + 200,
#end
#if ($tieneGrilla == "S")
				height: ${ventanaHeight} + 150,
#end
#if ($tieneGrilla != "S")
				height: ${ventanaHeight},
#end
				resizable: false,
				layout: 'fit',
				resizable: false,
				plain: true,
				bodyStyle: 'padding: 10px;',
				buttonAlign: 'center',
				items: form,
		        buttons: [{
		        	text: 'Aceptar',
		            disabled: false,
		            handler: function() {
		        		if(form.getForm().isValid()){
							form.getForm().submit({
			                	url: configObject.addUrl,
			                	success: function(response, options) {
			                		grid${clase}.getStore().load({
			                    		callback: function(recordArray, opts, success){}
			                		});
			                		win.close();
			                	},
			                	failure: function(response, options) {
			                		var responseText = Tera.decode(options.response.responseText);
			                		Tera.MessageBox.alert('Error en el Alta', responseText.failure);
			                	}
			                });
						}
					}
				},{
					text: 'Cancelar',
		            handler: function(){
		            	win.close();
					}
				}]
			});
			win.show(this);
		});
	    
	    buttonModificar.on('click', function(){
	    	if (!grid${clase}.getSelectionModel().hasSelection()) {
	    		return false;
	    	}
	    	Tera.MessageBox.confirm('Confirmar', '&iquest;Est&aacute; seguro que desea modificar el elemento seleccionado?', 
					function(btn){
						if ('yes' == btn) {
	    	
#if ($tieneGrilla == "S")		
			var storeGrilla2 = new Tera.data.JsonStore({
	            url: configObject.loadIdiomasUrl,
	            root: 'data',
	            totalProperty: 'totalCount',
	            id: 'codigo',
	            fields: ['codigo', 'descripcion']
	        });
	
	        var columnModel = new Tera.grid.ColumnModel([{
	            id: 'codigo',
	            header: "C&oacute;digo",
	            width: 30,
	            sortable: true,
	            dataIndex: 'codigo'
	        }, {
	            id: 'descripcion',
	            header: "Descripci&oacute;n",
	            width: 40,
	            sortable: true,
	            dataIndex: 'descripcion'
	        }]);
			var editableGrid = new Tera.grid.EditorGridPanel({
				clicksToEdit: 1,
	            store: storeGrilla2,
	            cm: columnModel,
	            stripeRows: true,
	            viewConfig: {
	                forceFit: true
	            },
	            style: 'padding-top: 10px',
	            width: ${ventanaWidth}-40,
	            height: 150,
	            frame: false
	        });
#end
	    	
	    	var recordToModify = grid${clase}.getSelectionModel().getSelected().data;
	    	var estado_readOnly = false;
#if ($tieneBaja == "S")
			if(recordToModify.fec_baja != null ){
				estado_readOnly = true;
			}
#end
			var form = new Tera.form.FormPanel({
				baseCls: 'x-plain',
				labelWidth: 130,
				items: [
#foreach($atributo in $camposForms)
#if ($atributo.getCampoExcel().getTieneLupa() == "S")

				new Tera.form.LupaField({
					fieldLabel: '${atributo.getEtiquetaCorta()}',
					width: ${atributo.getAnchoDelCampo()} + 17,
					id: '${atributo.getName().toLowerCase()}',
					name: '${atributo.getName().toLowerCase()}'
				})#if( $velocityCount < ${camposForms.size()}), #end
#end
#if ($atributo.getCampoExcel().getTieneLupa() != "S")

				{
#if ($atributo.getType() == "java.util.Date")
#if (!$atributo.getName().equalsIgnoreCase("FEC_BAJA"))
				xtype:'datefield', format: 'd/m/Y',
#end
#if ($atributo.getName().equalsIgnoreCase("FEC_BAJA"))
				xtype:'textfield', format: 'd/m/Y', readOnly: true,
#end
#end
#if ($atributo.getType() == "String")
	            xtype: 'textfield', 
#end
#if ($atributo.getType() == "Double" || $atributo.getType() == "java.math.BigDecimal")
	            xtype: 'numberfield', 
#end
				width: ${atributo.getAnchoDelCampo()},
				fieldLabel: '${atributo.getEtiquetaCorta()}',
				name: '${atributo.getName().toLowerCase()}',
				id: '${atributo.getName().toLowerCase()}',
				height: 21,
				maxLength: ${atributo.getMaxLen()},
				maxLengthText: 'El campo tiene un m&aacute;ximo de ${atributo.getMaxLen()} car&aacute;cteres',
#if ($atributo.getCampoExcel().getEsRequeridoAlta() == "S")				
				allowBlank: false,  
#end
#if ($atributo.getName().equalsIgnoreCase("FEC_ALTA"))
				readOnly: true,
#end 
#if (!$atributo.getName().equalsIgnoreCase("FEC_ALTA") && !$atributo.getName().equalsIgnoreCase("FEC_BAJA") )
#if ($atributo.getCampoExcel().getEsModificable() == "S")
				readOnly: estado_readOnly,  
#end
#if ($atributo.getCampoExcel().getEsModificable() != "S")
				readOnly: true,
#end
#end 
				msgTarget: 'side', 
				blankText: 'El campo es requerido',  
				value: recordToModify.${atributo.getName().toLowerCase()} 
				}#if( $velocityCount < ${camposForms.size()}), #end
#end
#end
#if ($tieneGrilla == "S")
				,editableGrid
#end
				]         
			});

			var win = new Tera.Window({
	        	title: 'Modificar',
			    modal: true,
#if (${lupas.size()} == 0)				
				width: ${ventanaWidth},
#end
#if (${lupas.size()} > 0)
				width: ${ventanaWidth} + 200,
#end
#if ($tieneGrilla == "S")
				height: ${ventanaHeight} + 150,
#end
#if ($tieneGrilla != "S")
				height: ${ventanaHeight},
#end
				resizable: false,
			    layout: 'fit',
			    plain:true,
			    bodyStyle:'padding: 10px;',
			    buttonAlign:'center',
				border: false,
				items: [ form ],
				buttons: [{
					text: 'Aceptar',
					disabled: false,
					handler: function() {
						if(form.getForm().isValid()){
							form.getForm().submit({
								url: configObject.modifyUrl,
								success: function(response, options) {
									grid${clase}.getStore().load({
										callback: function(recordArray, opts, success){}
									});
									win.close();
								},
								failure: function(response, options) {
									var responseText = Tera.decode(options.response.responseText);
									Tera.MessageBox.alert('Error en la Modificacion', responseText.failure);
								}
							});
						}
					}
				}, {
					text: 'Cancelar',
					handler: function(){
						win.close();
					}
				}]
			});
	        win.show();
	        
	        }});
	  });
	    
	    buttonBaja.on('click', function(e){
	    	if (grid${clase}.getSelectionModel().hasSelection()) {
#if ($tieneBaja =="S")
		    	if(grid${clase}.getSelectionModel().getSelected().data.fec_baja != null ){
					Tera.MessageBox.alert('Error', 'El elemento ya esta dado de baja');
					return -1;
				}
#end
	        	Tera.MessageBox.confirm('Confirmar', '&iquest;Est&aacute; seguro que desea eliminar el elemento seleccionado?', function(btn){
	        		if ('yes' == btn) {
#foreach($key in $keys)
            		var cod${clase}${key.getNameConFormato()} = grid${clase}.getSelectionModel().getSelected().data.${key.getName().toLowerCase()};
#end
	            		var cod${clase} = grid${clase}.getSelectionModel().getSelected().data.cod${clase};
	            		Tera.Ajax.request({
	            			url : configObject.removeUrl , 
	            			params : {
#foreach($key in $keys)
            		'${key.getName().toLowerCase()}': cod${clase}${key.getNameConFormato()}#if( $velocityCount < ${keys.size()}), #end

#end	            			
	            			
	            			},
	            			method: 'POST',
	            			callback: function(options, success, response) {
								var data = Tera.decode(response.responseText);
									if (data.success) {
										grid${clase}.getStore().load();
									} else {
										var responseText = Tera.decode(options.response.responseText);
										Tera.MessageBox.alert('Error en la Baja', responseText.failure);
									}
								}
	            		});
	            	}
				});
	    	}
	    });
	    
	    buttonVisualizar.on('click', function(){
			if (!grid${clase}.getSelectionModel().hasSelection()) {
				return false;
			}

			var recordToShow = grid${clase}.getSelectionModel().getSelected().data;

			var form = new Tera.form.FormPanel({
				baseCls: 'x-plain',
				labelWidth: 130,
				items: [
#foreach($atributo in $atributos)
				{
#if ($atributo.getType() == "java.util.Date")
					xtype:'textfield', format: 'd/m/Y', 
#end
#if ($atributo.getType() == "String")
		            xtype: 'textfield', 
#end
#if ($atributo.getType() == "Double" || $atributo.getType() == "java.math.BigDecimal")
	    	        xtype: 'numberfield', 
#end
					width: ${atributo.getAnchoDelCampo()},
					fieldLabel: '${atributo.getEtiquetaCorta()}',
					id: '${atributo.getName().toLowerCase()}',
					readOnly: true,
					name: '${atributo.getName().toLowerCase()}',
					height: 21,
					value: recordToShow.${atributo.getName().toLowerCase()} 
				}#if( $velocityCount < ${atributos.size()}), #end
#end
]
			});
			
			var win = new Tera.Window({
				title: 'Visualizar',
				width: ${ventanaWidth2},
				height: ${ventanaHeight2},
				resizable: false,
				modal: true,
				layout: 'fit',
				plain: true,
				bodyStyle: 'padding: 10px;',
				buttonAlign:'center',
				border: false,
				items: [ form ],
				buttons: [{
					text:'Cerrar',
					handler: function() {
						win.close();
					}
				}]
			});
	        win.show(this);
	    });
	    
	});
</script>
	
<div id="panel${clase}"></div>